part of xwidgetbase;

class XItemWidget extends StatelessWidget {
  final Widget? child;
  final String title;
  final Color? titleBackColor;
  final double? titleHeight;
  final double? heightChildContainer;
  final Widget? childBTNBottom;
  final TextStyle? titleStyle;
  final List<Widget>? childrenForHeaders;
  final AlignmentGeometry? titleAlignment;
  double borderWidth;
  final Color? backGroundColorInternalWidget;
  final Decoration? decorationXItemWidget;
  final BorderRadiusGeometry? borderRadiusOfItemWidget;
  final bool borderAll;
  final bool borderVisible;
  final bool borderOnBottom;

  XItemWidget({
    Key? key,
    this.childrenForHeaders,
    this.titleAlignment,
    this.heightChildContainer,
    this.borderAll = true,
    this.backGroundColorInternalWidget,
    this.titleStyle,
    this.childBTNBottom,
    this.child,
    this.title = "",
    this.titleBackColor = Colors.transparent,
    this.borderVisible = true,
    this.borderOnBottom = false,
    this.borderRadiusOfItemWidget,
    this.decorationXItemWidget,
    this.borderWidth = 1.0,
    this.titleHeight,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    // var size = MediaQuery.of(context).size.height;
    return Container(
      // margin: EdgeInsets.all(3),
      decoration: decorationXItemWidget ??
          BoxDecoration(
              color: backGroundColorInternalWidget ?? Colors.grey[900],
              border: borderVisible
                  ? borderAll == true
                      ? Border.all(width: borderWidth, color: titleBackColor!)
                      : Border(
                          bottom: BorderSide(width: borderWidth, color: titleBackColor!),
                          left: BorderSide(width: borderWidth, color: titleBackColor!),
                          right: BorderSide(width: borderWidth, color: titleBackColor!),
                        )
                  : null,
              borderRadius: borderRadiusOfItemWidget),
      child: Column(mainAxisSize: MainAxisSize.min, children: [
        title != ""
            ? Container(
                color: titleBackColor,
                child: Row(
                  children: [
                    Expanded(
                      flex: 8,
                      child: Container(
                        // margin: EdgeInsets.only(left: 10),
                        height: titleHeight ?? 35,
                        decoration: BoxDecoration(borderRadius: borderRadiusOfItemWidget, color: titleBackColor),
                        alignment: titleAlignment ?? Alignment.centerLeft,
                        child: Text(" " + title, style: titleStyle ?? XStyles.xStyTextForLabel()),
                      ),
                    ),
                    childBTNBottom == null
                        ? Container()
                        : Expanded(
                            child: Container(
                              color: titleBackColor,
                              height: 40,
                              child: childBTNBottom,
                            ),
                          ),
                  ],
                ),
              )
            : Container(),
        Row(children: childrenForHeaders ?? [Container()]),
        Container(
          color: backGroundColorInternalWidget ?? null,
          alignment: Alignment.centerLeft,
          height: heightChildContainer ?? null,
          child: child ?? Container(),
        ),
      ]),
    );
  }
}
